//=========================================================
// src/Interrupts.c: generated by Hardware Configurator
//
// This file will be regenerated when saving a document.
// leave the sections inside the "$[...]" comment tags alone
// or they will be overwritten!
//=========================================================


// USER INCLUDES
#include <SI_EFM8UB1_Register_Enums.h>
#include "SoundSynthesizer_Defs.h"

//variables
unsigned int PCA0Mod0_Compare_Value;
unsigned int PCA0Mod1_Compare_Value;
unsigned int Current_SoundSignal_Increment;
unsigned int Current_FilterClock_Increment;

//-----------------------------------------------------------------------------
// PCA0_ISR
//-----------------------------------------------------------------------------
//
// PCA0 ISR Content goes here. Remember to clear flag bits:
// PCA0CN0::CCF0 (PCA Module 0 Capture/Compare Flag)
// PCA0CN0::CCF1 (PCA Module 1 Capture/Compare Flag)
// PCA0CN0::CCF2 (PCA Module 2 Capture/Compare Flag)
// PCA0CN0::CF (PCA Counter/Timer Overflow Flag)
// PCA0PWM::COVF (Cycle Overflow Flag)
//
//-----------------------------------------------------------------------------
SI_INTERRUPT (PCA0_ISR, PCA0_IRQn)
{
	if(PCA0CN0_CCF0)	//this channel generates the sound-signal frequency
	{
		PCA0CN0_CCF0 = 0;		//clear the interrupt flag
		PCA0Mod0_Compare_Value = PCA0Mod0_Compare_Value + Current_SoundSignal_Increment;
		PCA0CPL0 = LOWBYTE(PCA0Mod0_Compare_Value);	//must write low byte first
		PCA0CPH0 = HIGHBYTE(PCA0Mod0_Compare_Value);
	}

	if(PCA0CN0_CCF1)	//this channel generates the filter-clock frequency
	{
		PCA0CN0_CCF1 = 0;		//clear the interrupt flag
		PCA0Mod1_Compare_Value = PCA0Mod1_Compare_Value + Current_FilterClock_Increment;
		PCA0CPL1 = LOWBYTE(PCA0Mod1_Compare_Value);	//must write low byte first
		PCA0CPH1 = HIGHBYTE(PCA0Mod1_Compare_Value);
	}
}



